package dev.shadowsoffire.apotheosis.ench.enchantments.masterwork;

import net.minecraft.world.entity.player.Player;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Items;
import dev.shadowsoffire.apotheosis.Apoth;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraft.world.level.ItemLike;
import net.minecraftforge.common.Tags;
import net.minecraftforge.event.level.BlockEvent;
import net.minecraft.ChatFormatting;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.network.chat.Component;
import net.minecraft.world.entity.EquipmentSlot;
import dev.shadowsoffire.apotheosis.ench.EnchModule;
import net.minecraft.world.item.enchantment.Enchantment;

public class EarthsBoonEnchant extends Enchantment
{
    public EarthsBoonEnchant() {
        super(Enchantment.Rarity.VERY_RARE, EnchModule.PICKAXE, new EquipmentSlot[] { EquipmentSlot.MAINHAND });
    }
    
    public int m_6586_() {
        return 3;
    }
    
    public int m_6183_(final int level) {
        return 60 + (level - 1) * 20;
    }
    
    public int m_6175_(final int enchantmentLevel) {
        return 200;
    }
    
    public Component m_44700_(final int level) {
        return (Component)((MutableComponent)super.m_44700_(level)).m_130940_(ChatFormatting.DARK_GREEN);
    }
    
    public void provideBenefits(final BlockEvent.BreakEvent e) {
        final Player player = e.getPlayer();
        final ItemStack stack = player.m_21205_();
        final int level = stack.getEnchantmentLevel((Enchantment)this);
        if (player.m_9236_().f_46443_) {
            return;
        }
        if (e.getState().m_204336_(Tags.Blocks.STONE) && level > 0 && player.f_19796_.m_188501_() <= 0.01f * level) {
            final ItemStack newDrop = new ItemStack((ItemLike)ForgeRegistries.ITEMS.tags().getTag(Apoth.Tags.BOON_DROPS).getRandomElement(player.f_19796_).orElse(Items.f_41852_));
            Block.m_49840_(player.m_9236_(), e.getPos(), newDrop);
        }
    }
}
